;montres grs
;01-goomba
;02-tortue
;03-carapace
;04-plante
;05-boule de feu
;06-pierre
;07-tortue volante
;08-missile
;09-boule de canon haut gauche
;10-boule de canon bas gauche
;11-poisson
;12-bowser
;13-barre de fin
;14-barre verticale
;15-barre horizontale
;16-champignon
;17-champignon_noir
;18-etoile
;19-fleur
;20-boule de feu tir par la plante

monstres:
 LD HL,ennemis_affiches
monstres2:
 LD A,(HL)
 CP 1
 JR Z,gere_goomba
 CP 2
 JP Z,gere_tortue
 CP 3
 JP Z,gere_carapace
 CP 4
 JP Z,gere_plante
 CP 5
 JP Z,gere_boule_de_feu
 CP 6
 JP Z,gere_pierre
 CP 7
 JP Z,gere_tortue_volante
 CP 8
 JP Z,gere_missile
 CP 9
 JP Z,gere_bdchg
 CP 10
 JP Z,gere_bdcbg
 CP 11
 JP Z,gere_poisson
 ;CP 12             ;  grer plus tard
 ;JP Z,gere_bowser
 CP 13
 JP Z,gere_barre_de_fin
 CP 14
 JP Z,gere_barre_verticale
 CP 15
 JP Z,gere_barre_horizontale
 CP 16
 JP Z,gere_champignon
 CP 17
 JP Z,gere_champignon_noir
 CP 18
 JP Z,gere_etoile
 ;CP 19
 ;JP Z,gere_fleur
 CP 20
 JP Z,gere_boule_de_feu_plante
il_y_a_encore_des_monstres:
 LD BC,7
 ADD HL,BC
 LD DE,ennemis_affiches+224
 CALL CP_HL_DE
 RET Z
 JR monstres2
;----------------------------------------GOOMBA---------------------------------------------
gere_goomba:
 LD (buffer16),HL
 INC HL
 INC HL
;dplace goomba
 PUSH HL
 LD BC,4
 ADD HL,BC
 LD A,(HL)
 CP 2
 JR NC,attend_un_peu_goomba
 INC A
 LD (HL),A
 POP HL
 LD B,(HL)
 JP affiche_goomba
attend_un_peu_goomba:
 XOR A
 LD (HL),A
 POP HL
;goomba risque de tomber ?
 DEC HL
 LD A,(HL)
 CP 1
 jr Z,teste_a_droite_goomba
;teste_a_gauche_goomba
 INC HL
 LD A,(HL) ;A=x
 ADD A,2
 JR teste_tortue_bas_goomba
teste_a_droite_goomba:
 INC HL
 LD A,(HL) ;A=x
 ADD A,2
teste_tortue_bas_goomba:
 JP P,pas_negatif_goomba
 NEG
 SRL A;
 SRL A; A=A/8
 SRL A;
 NEG
 JR fin_pos_neg_goomba
pas_negatif_goomba:
 SRL A;
 SRL A; A=A/8
 SRL A;
 INC A
fin_pos_neg_goomba:
 INC HL
 INC HL
 ADD A,(HL)
 DEC HL
 PUSH HL
 LD C,(HL)
 LD B,0
 SRL C;
 SRL C; C=C/8
 SRL C;
 INC C
 LD HL,(long_de_la_carte)
 CALL MUL_HL_BC
 LD D,0
 LD E,A
 ADD HL,DE
 LD DE,CurMap
 ADD HL,DE
 LD (buffer16_2),HL
 LD A,(HL)
 OR A;CP 0
 JR Z,pas_de_collision_goomba_bas
 CP 41
 JR C,collision_goomba_bas
pas_de_collision_goomba_bas:
 POP HL
 PUSH HL
 LD A,(HL)
 INC A
 LD (HL),A
collision_goomba_bas:
 POP HL
 PUSH HL
 DEC HL
;goomba peut avancer?
 LD HL,(buffer16)
 INC HL
 LD A,(HL)
 OR A
 JR Z,test_gauche_goomba
 LD HL,(buffer16_2)
 LD DE,(long_de_la_carte)
 SBC HL,DE
 INC HL
 JR fin_test_goomba
test_gauche_goomba:
 LD HL,(buffer16_2)
 LD DE,(long_de_la_carte)
 SBC HL,DE
fin_test_goomba:
 LD A,(HL)
 OR A;CP 0
 JR Z,pas_de_collision_goomba_cote
 CP 41
 JR C,collision_goomba_cote
pas_de_collision_goomba_cote:
 POP HL
 DEC HL
;goomba doit se deplacer  gauche ou  droite?
 PUSH HL
 DEC HL
 LD A,(HL)
 CP 1
 JR Z,vers_droite_goomba
;vers_gauche_goomba
 POP HL
 LD B,(HL) ;B=nombre  ajouter  (colonne*8) pour avoir la coordonne x
 DEC B
 LD (HL),B
 JR affiche_goomba
vers_droite_goomba:
 POP HL
 LD B,(HL) ;B=nombre  ajouter  (colonne*8) pour avoir la coordonne x
 INC B
 LD (HL),B
 JR affiche_goomba
collision_goomba_cote:
;
 POP HL
 DEC HL
;goomba doit se deplacer  gauche ou  droite?
 PUSH HL
 DEC HL
 LD A,(HL)
 CP 1
 JR Z,met_0_goomba2
;met_1_goomba2
 SET 0,A            ; A = 1
 JR fin_met_goomba2
met_0_goomba2:
 RES 0,A            ; A = 0
fin_met_goomba2:
 LD (HL),A
 POP HL
 INC HL
 PUSH HL
 JR pas_de_collision_goomba_cote
affiche_goomba:
 INC HL
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 LD B,A
 ADD A,8
 CP 8
 JP C,mechant_disparait
;collision avec Mario
 PUSH BC
 LD A,B
 SUB 8
 LD B,A
 LD A,(x_mario)
 CP B
 JR C,le_mechant_est_derriere_m
;le mchant est il derrire Mario?
 LD A,B
 ADD A,16
 LD B,A
 LD A,(x_mario)
 CP B
 JR NC,le_mechant_est_devant_m
 DEC HL
 LD C,(HL)
 INC HL
 LD A,(y_mario)
 ADD A,3
 CP C
 JR NC,goomba_ou_mario_pas_mort
 ADD A,7
 CP C
 JR Z,goomba_meurt
 CP C
 JR C,goomba_ou_mario_pas_mort
 POP BC
 POP BC ;annule le call
 JP mario_est_mort
goomba_meurt:
 POP BC
 PUSH HL
 DEC HL
 LD A,(HL)
 ADD A,6
 LD C,A
 LD A,2
 LD DE,goomba_ecrase
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 POP HL
 JP mechant_disparait
le_mechant_est_devant_m:
le_mechant_est_derriere_m:
goomba_ou_mario_pas_mort:
 POP BC
 DEC HL
 LD C,(HL)
 LD A,8
 LD DE,goomba
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

;----------------------------------------TORTUE---------------------------------------------
gere_tortue:
 LD (buffer16),HL
 INC HL
 INC HL
;dplace tortue
 PUSH HL
 LD BC,4
 ADD HL,BC
 LD A,(HL)
 CP 2
 JR NC,attend_un_peu_tortue
 INC A
 LD (HL),A
 POP HL
 LD B,(HL)
 JP affiche_tortue
attend_un_peu_tortue:
 XOR A
 LD (HL),A
 POP HL
;tortue risque de tomber ?
 DEC HL
 LD A,(HL)
 CP 1
 jr Z,teste_a_droite
;teste_a_gauche
 INC HL
 LD A,(HL) ;A=x
 ADD A,4
 JR teste_tortue_bas
teste_a_droite:
 INC HL
 LD A,(HL) ;A=x
 ADD A,4
teste_tortue_bas:
 NEG
 SRL A;
 SRL A; A=A/8
 SRL A;
 NEG
 INC HL
 INC HL
 ADD A,(HL)
 DEC HL
 PUSH HL
 LD C,(HL)
 LD B,0
 SRL C;
 SRL C; C=C/8
 SRL C;
 INC C
 LD HL,(long_de_la_carte)
 CALL MUL_HL_BC
 LD D,0
 LD E,A
 ADD HL,DE
 LD DE,CurMap
 ADD HL,DE
 LD (buffer16_2),HL
 LD A,(HL)
 OR A;CP 0
 JR Z,pas_de_collision_tortue_bas
 CP 41
 JR C,collision_tortue_bas
pas_de_collision_tortue_bas:
 POP HL
 PUSH HL
 DEC HL
 DEC HL
 LD A,(HL)
 CP 1
 JR Z,met_0_tortue
;met_1_tortue
 SET 0,A            ; A = 1
 JR fin_met_tortue
met_0_tortue:
 RES 0,A            ; A = 0
fin_met_tortue:
 LD (HL),A
collision_tortue_bas:
 POP HL
 PUSH HL
 DEC HL
;tortue peut avancer?
 LD HL,(buffer16_2)
 LD DE,(long_de_la_carte)
 SBC HL,DE

 LD A,(HL)
 OR A;CP 0
 JR Z,pas_de_collision_tortue_cote
 CP 41
 JR C,collision_tortue_cote
pas_de_collision_tortue_cote:
 POP HL
 DEC HL
;la tortue doit se deplacer  gauche ou  droite?
 PUSH HL
 DEC HL
 LD A,(HL)
 CP 1
 JR Z,vers_droite
;vers_gauche
 POP HL
 LD B,(HL) ;B=nombre  ajouter  (colonne*8) pour avoir la coordonne x
 DEC B
 LD (HL),B
 JR affiche_tortue
vers_droite:
 POP HL
 LD B,(HL) ;B=nombre  ajouter  (colonne*8) pour avoir la coordonne x
 INC B
 LD (HL),B
 JR affiche_tortue
collision_tortue_cote:
;
 POP HL
 DEC HL
;la tortue doit se deplacer  gauche ou  droite?
 PUSH HL
 DEC HL
 LD A,(HL)
 CP 1
 JR Z,met_0_tortue2
;met_1_tortue2
 SET 0,A            ; A = 1
 JR fin_met_tortue2
met_0_tortue2:
 RES 0,A            ; A = 0
fin_met_tortue2:
 LD (HL),A
 POP HL
affiche_tortue:
 INC HL
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 LD B,A
 ADD A,8
 CP 8
 JP C,mechant_disparait
;collision avec Mario
 PUSH BC
 LD A,B
 SUB 8
 LD B,A
 LD A,(x_mario)
 CP B
 JR C,tortue_est_derriere_m
;tortue est il derrire Mario?
 LD A,B
 ADD A,16
 LD B,A
 LD A,(x_mario)
 CP B
 JR NC,tortue_est_devant_m
 DEC HL
 LD C,(HL)
 INC HL
 LD A,(y_mario)
 ADD A,3
 CP C
 JR NC,tortue_ou_mario_pas_mort
 ADD A,7
 CP C
 JR Z,tortue_meurt
 CP C
 JR C,tortue_ou_mario_pas_mort
 POP BC
 POP BC ;annule le call
 JP mario_est_mort
tortue_meurt:
 POP BC
;on transforme la tortue en carapace
 LD HL,(buffer16)
 LD (HL),3
 INC HL
 LD (HL),1
 LD A,1
 LD (saut),A
 JR sprite_trop_haut
tortue_est_devant_m:
tortue_est_derriere_m:
tortue_ou_mario_pas_mort:
 POP BC
 DEC HL
 LD A,(HL)
 SUB 4
 JR C,sprite_trop_haut ;au cas o le sprite est trop haut
 LD C,A
 LD A,12
 PUSH AF
 LD HL,(buffer16)
 INC HL
 LD A,(HL)
 OR A ;CP 0
 JR Z,tortue_gauche
;tortue_droite
 LD DE,tortue+24
 JR aff_tortue_bon_sens
tortue_gauche:
 LD DE,tortue
aff_tortue_bon_sens:
 POP AF
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
sprite_trop_haut:
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

;----------------------------------------MISSILE-------------------------------------------
gere_missile:
 LD (buffer16),HL
 INC HL
 INC HL
;dplace missile
 PUSH HL
 LD BC,4
 ADD HL,BC
 LD A,(HL)
 CP 2
 JR NC,attend_un_peu_missile
 INC A
 LD (HL),A
 POP HL
 LD B,(HL)
 JR affiche_missile
attend_un_peu_missile:
 XOR A
 LD (HL),A
 POP HL
 LD B,(HL) ;B=nombre  ajouter  (colonne*8) pour avoir la coordonne x
 DEC B
 LD (HL),B
affiche_missile:
 INC HL
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 LD B,A
 ADD A,8
 CP 8
 JP NC,p_retire_un_missile
 DEC HL
 DEC HL
 LD A,(HL)
 INC HL
 INC HL
 CP -10
 JP Z,mechant_disparait
 DEC HL
 DEC HL
 LD (HL),-10
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres
p_retire_un_missile:
;collision avec Mario
 PUSH BC
 LD A,B
 SUB 8
 LD B,A
 LD A,(x_mario)
 CP B
 JR C,missile_est_derriere_m
;missile est il derrire Mario?
 LD A,B
 ADD A,16
 LD B,A
 LD A,(x_mario)
 CP B
 JR NC,missile_est_devant_m
 DEC HL
 LD C,(HL)
 INC HL
 LD A,(y_mario)
 SUB 3
 CP C
 JR NC,missile_ou_mario_pas_mort
 ADD A,10
 CP C
 JR C,missile_ou_mario_pas_mort
 POP BC
 POP BC ;annule le call
 JP mario_est_mort
missile_est_devant_m:
missile_est_derriere_m:
missile_ou_mario_pas_mort:
 POP BC
 DEC HL
 LD A,(HL)
 LD C,A
 LD A,8
 LD DE,missile
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

;----------------------------------------PLANTE--------------------------------------------
gere_plante:
 LD (buffer16),HL
 INC HL
 INC HL
;dplace plante
 PUSH HL
 LD BC,4
 ADD HL,BC
 LD A,(HL)
 CP 2
 JR NC,attend_un_peu_plante
 INC A
 LD (HL),A
 POP HL
 LD B,(HL)
 JR affiche_plante
attend_un_peu_plante:
 XOR A
 LD (HL),A
 POP HL
 PUSH HL
 DEC HL
;HL -> direction
 LD A,(HL)
 INC HL
 INC HL
 CP 1
 JR Z,plante_monte
;plante_dessent
 LD A,(HL) ; HL -> y
 INC A
 LD (HL),A
;vrifie si la plante n'est pas trop bas
 INC HL\ INC HL
 SUB (HL)
 CP 12
 JR NZ,mouvement_plante
 DEC HL\ DEC HL\ DEC HL\ DEC HL
 LD A,1
 LD (HL),A
 JR mouvement_plante
plante_monte:
 LD A,(HL) ; HL -> y
 DEC A
 LD (HL),A
;vrifie si la plante n'est pas trop haute
 INC HL\ INC HL
 SUB (HL)
 OR A
 JR NZ,mouvement_plante
 DEC HL\ DEC HL\ DEC HL\ DEC HL
 LD A,0
 LD (HL),A
;crache une boule de feu
 LD HL,(buffer16)
 LD DE,7
 ADD HL,DE
 LD (buffer16),HL
 CALL insere_ennemis
 LD (HL),20
 INC HL
 LD (HL),0
 INC HL
 LD (HL),-10
 INC HL
 LD DE,(buffer16)
 INC DE\ INC DE\ INC DE
 LD A,(DE)
 SUB 4
 LD (HL),A
 LD B,A
 INC HL
 INC DE
 LD A,(DE)
 LD (HL),A
 INC HL
 LD (HL),B
 INC HL
 LD (HL),0
 LD DE,7
 LD HL,(pointeur_ennemis_affiches)
 ADD HL,DE
 LD (pointeur_ennemis_affiches),HL
 POP HL
 ADD HL,DE
 PUSH HL
mouvement_plante:
 POP HL
 LD B,(HL)
affiche_plante:
;n'affiche qu'une partie de la plante
 PUSH HL
 INC HL
 LD A,(HL)
 INC HL\ INC HL
 SUB (HL)
 LD (long_sprite_affich),A
 POP HL
 INC HL
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 ADD A,4
 LD B,A
 ADD A,8
 CP 8
 JP C,mechant_disparait
;collision avec Mario
 PUSH BC
 LD A,B
 SUB 8
 LD B,A
 LD A,(x_mario)
 CP B
 JR C,plante_est_derriere_m
;plante est il derrire Mario?
 LD A,B
 ADD A,16
 LD B,A
 LD A,(x_mario)
 CP B
 JR NC,plante_est_devant_m
 DEC HL
 LD C,(HL)
 INC HL
 LD A,(y_mario)
 ADD A,3
 CP C
 JR NC,plante_ou_mario_pas_mort
 ADD A,7
 CP C
 JR C,plante_ou_mario_pas_mort
 POP BC
 POP BC ;annule le call
 JP mario_est_mort
plante_est_devant_m:
plante_est_derriere_m:
plante_ou_mario_pas_mort:
 POP BC
 DEC HL
 LD A,(HL)
 SUB 4
 LD C,A
 LD A,13
 LD DE,plante
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 XOR A
 LD (long_sprite_affich),A
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

;----------------------------------------BARRE DE FIN---------------------------------------
gere_barre_de_fin:
 LD (buffer16),HL
 INC HL
 INC HL
;dplace barre_de_fin
 PUSH HL
 LD BC,4
 ADD HL,BC
 LD A,(HL)
 CP 2
 JR NC,attend_un_peu_barre_de_fin
 INC A
 LD (HL),A
 POP HL
 LD B,(HL)
 JR affiche_barre_de_fin
attend_un_peu_barre_de_fin:
 XOR A
 LD (HL),A
 POP HL
 PUSH HL
 DEC HL
;HL -> direction
 LD A,(HL)
 INC HL
 INC HL
 CP 1
 JR Z,barre_de_fin_monte
;barre_de_fin_dessent
 LD A,(HL) ; HL -> y
 INC A
 LD (HL),A
;vrifie si la barre_de_fin n'est pas trop bas
 INC HL\ INC HL
 SUB (HL)
 CP 40
 JR NZ,mouvement_barre_de_fin
 DEC HL\ DEC HL\ DEC HL\ DEC HL
 LD A,1
 LD (HL),A
 JR mouvement_barre_de_fin
barre_de_fin_monte:
 LD A,(HL) ; HL -> y
 DEC A
 LD (HL),A
;vrifie si la barre_de_fin n'est pas trop haute
 INC HL\ INC HL
 SUB (HL)
 OR A
 JR NZ,mouvement_barre_de_fin
 DEC HL\ DEC HL\ DEC HL\ DEC HL
 LD A,0
 LD (HL),A
mouvement_barre_de_fin:
 POP HL
 LD B,(HL)
affiche_barre_de_fin:
 INC HL
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 SUB 4
 LD B,A
 ADD A,8
 CP 8
 JP C,mechant_disparait
;collision avec Mario
 PUSH BC
 LD A,B
 SUB 12
 LD B,A
 LD A,(x_mario)
 CP B
 JR C,barre_de_fin_est_derriere_m
;barre_de_fin est il derrire Mario?
 LD A,B
 ADD A,20
 LD B,A
 LD A,(x_mario)
 CP B
 JR NC,barre_de_fin_est_devant_m
 DEC HL
 LD C,(HL)
 INC HL
 LD A,(y_mario)
 ADD A,3
 CP C
 JR NC,barre_de_fin_ou_mario_pas_mort
 ADD A,7
 CP C
 JR C,barre_de_fin_ou_mario_pas_mort
 POP BC
 POP BC ;annule le call
 JP charge_niv_suivant
barre_de_fin_est_devant_m:
barre_de_fin_est_derriere_m:
barre_de_fin_ou_mario_pas_mort:
 POP BC
 DEC HL
 LD A,(HL)
 ADD A,4
 LD C,A
 LD A,4
 LD DE,barre_de_fin
 PUSH BC
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 POP BC
 LD A,B
 ADD A,8
 LD B,A
 LD A,4
 LD DE,barre_de_fin+8
 CALL GRAYSPRITE
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

;----------------------------------------BARRE VERTICALE------------------------------------
gere_barre_verticale:
 LD (buffer16),HL
 INC HL
 INC HL
;dplace barre_verticale
 PUSH HL
 LD BC,4
 ADD HL,BC
 LD A,(HL)
 CP 2
 JR NC,attend_un_peu_barre_verticale
 INC A
 LD (HL),A
 POP HL
 LD B,(HL)
 JR affiche_barre_verticale
attend_un_peu_barre_verticale:
 XOR A
 LD (HL),A
 POP HL
 PUSH HL
 DEC HL
;HL -> direction
 LD A,(HL)
 INC HL
 INC HL
 CP 1
 JR Z,barre_verticale_monte
;barre_verticale_dessent
 LD A,(HL) ; HL -> y
 INC A
 LD (HL),A
;vrifie si la barre_verticale n'est pas trop bas
 INC HL\ INC HL
 SUB (HL)
 CP 32
 JR NZ,mouvement_barre_verticale
 DEC HL\ DEC HL\ DEC HL\ DEC HL
 LD A,1
 LD (HL),A
 JR mouvement_barre_verticale
barre_verticale_monte:
 LD A,(HL) ; HL -> y
 DEC A
 LD (HL),A
;vrifie si la barre_verticale n'est pas trop haute
 INC HL\ INC HL
 SUB (HL)
 OR A
 JR NZ,mouvement_barre_verticale
 DEC HL\ DEC HL\ DEC HL\ DEC HL
 LD A,0
 LD (HL),A
mouvement_barre_verticale:
 POP HL
 LD B,(HL)
affiche_barre_verticale:
 INC HL
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 LD B,A
 ADD A,8
 CP 8
 JP C,mechant_disparait
;collision avec Mario
 PUSH BC
 LD A,B
 SUB 8
 LD B,A
 LD A,(x_mario)
 CP B
 JR C,barre_verticale_est_derriere_m
;barre_verticale est il derrire Mario?
 LD A,B
 ADD A,16
 LD B,A
 LD A,(x_mario)
 CP B
 JP NC,barre_verticale_est_devant_m
 DEC HL
 LD C,(HL)
 INC HL
 LD A,(y_mario)
 ADD A,1
 CP C
 JP NC,barre_vert_ou_mario_pas_mort
 ADD A,5
 CP C
 JP C,barre_vert_ou_mario_pas_mort
;mario est sur de la barre, il doit dessendre ou monter avec.
 XOR A
 LD (saut),A
 PUSH HL
 INC HL
 LD A,(HL)
 OR A
 JR NZ,mario_monte_barre_verticale
;mario_dessent_barre_verticale
 LD A,(y_mario)
 DEC A
 DEC A
 LD (y_mario),A
 JR mario_est_deplace_bar_vert
mario_monte_barre_verticale:
 LD A,(y_mario)
 DEC A
 DEC A
 DEC A
 LD (y_mario),A
mario_est_deplace_bar_vert:
 POP HL
barre_verticale_est_devant_m:
barre_verticale_est_derriere_m:
barre_vert_ou_mario_pas_mort:
 POP BC
 DEC HL
 LD A,(HL)
 ADD A,5
 LD C,A
 LD A,3
 LD DE,barre
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

;----------------------------------------BARRE HORIZONTALE----------------------------------
gere_barre_horizontale:
 LD (buffer16),HL
 INC HL
 INC HL
;dplace barre_horizontale
 PUSH HL
 LD BC,4
 ADD HL,BC
 LD A,(HL)
 CP 2
 JR NC,attend_un_peu_barre_horizontale
 INC A
 LD (HL),A
 POP HL
 LD B,(HL)
 JR affiche_barre_horizontale
attend_un_peu_barre_horizontale:
 XOR A
 LD (HL),A
 POP HL
 PUSH HL
 DEC HL
;HL -> direction
 LD A,(HL)
 INC HL
 CP 1
 JR Z,barre_horizontale_gauche
;barre_horizontale_droite
 LD A,(HL) ; HL -> x
 INC A
 LD (HL),A
;vrifie si la barre_horizontale n'est pas trop  droite
 CP 48
 JR NZ,mouvement_barre_horizontale
 DEC HL
 LD A,1
 LD (HL),A
 JR mouvement_barre_horizontale
barre_horizontale_gauche:
 LD A,(HL) ; HL -> x
 DEC A
 LD (HL),A
;vrifie si la barre_horizontale n'est pas trop  gauche
 CP -10
 JR NZ,mouvement_barre_horizontale
 DEC HL
 LD A,0
 LD (HL),A
mouvement_barre_horizontale:
 POP HL
 LD B,(HL)
affiche_barre_horizontale:
 INC HL
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 LD B,A
 ADD A,8
 CP 8
 JP C,mechant_disparait
 CP 88
 JP NC,affich_pas_barre
;collision avec Mario
 PUSH BC
 LD A,B
 SUB 8
 LD B,A
 LD A,(x_mario)
 CP B
 JR C,barre_horiz_est_derriere_m
;barre_horiz est il derrire Mario?
 LD A,B
 ADD A,16
 LD B,A
 LD A,(x_mario)
 CP B
 JP NC,barre_horiz_est_devant_m
 DEC HL
 LD C,(HL)
 INC HL
 LD A,(y_mario)
 ADD A,3
 CP C
 JP NC,barre_horiz_ou_mario_pas_mort
 ADD A,5
 CP C
 JP C,barre_horiz_ou_mario_pas_mort
;mario est sur de la barre, il doit la suivre.
 XOR A
 LD (saut),A
 LD A,(y_mario)
 DEC A
 DEC A
 LD (y_mario),A
 PUSH HL
 LD HL,(buffer16)
 LD BC,6
 ADD HL,BC
 LD A,(HL)
 POP HL
 CP 2
 JR C,barre_horiz_ou_mario_pas_mort
 PUSH HL
 LD HL,(buffer16)
 INC HL
 LD A,(HL)
 OR A
 JR NZ,mario_gauch_barre_horiz
;mario_droit_barre_horiz
 call verifie_collision_droite
 OR A
 JR NZ,mario_est_deplace_bar_horiz
 LD A,(x_mario)
 CP 48
 JR NC,decal_monde_barre_vert
 INC A
 LD (x_mario),A
 JR mario_est_deplace_bar_horiz
decal_monde_barre_vert:
 call decale_monde
 LD A,(x_mario)
 DEC A
 LD (x_mario),A
 JR mario_est_deplace_bar_horiz
mario_gauch_barre_horiz:
 LD A,(x_mario)
 DEC A
 LD (x_mario),A
mario_est_deplace_bar_horiz:
 POP HL
barre_horiz_est_devant_m:
barre_horiz_est_derriere_m:
barre_horiz_ou_mario_pas_mort:
 POP BC
 DEC HL
 LD A,(HL)
 ADD A,5
 LD C,A
 LD A,3
 LD DE,barre
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
affich_pas_barre:
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

;----------------------------------------POISSON-------------------------------------------
gere_poisson:
 LD (buffer16),HL
 INC HL
 INC HL
 INC HL
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 SUB 10
 LD B,A
 ADD A,8
 CP 8
 JP C,mechant_disparait
;collision avec Mario
 PUSH BC
 LD A,B
 SUB 8
 LD B,A
 LD A,(x_mario)
 CP B
 JR C,poisson_est_derriere_m
;poisson est il derrire Mario?
 LD A,B
 ADD A,16
 LD B,A
 LD A,(x_mario)
 CP B
 JR NC,poisson_est_devant_m
 DEC HL
 LD C,(HL)
 INC HL
 LD A,(y_mario)
 SUB 3
 CP C
 JR NC,poisson_ou_mario_pas_mort
 ADD A,10
 CP C
 JR C,poisson_ou_mario_pas_mort
 POP BC
 POP BC ;annule le call
 JP mario_est_mort
poisson_est_devant_m:
poisson_est_derriere_m:
poisson_ou_mario_pas_mort:
 POP BC
 DEC HL
 LD A,(HL)
 LD C,A
 LD HL,(buffer16)
 LD DE,6
 ADD HL,DE
 LD A,(HL)
 OR A
 JR Z,timer_poisson_0
;timer_poisson_1
 LD DE,poisson+16
 XOR A
 LD (HL),A
 JR fin_timer_poisson
timer_poisson_0:
 LD DE,poisson
 INC A
 LD (HL),A
fin_timer_poisson:
 LD A,8
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

;----------------------------------------CARAPACE---------------------------------------------
gere_carapace:
 LD (buffer16),HL
 INC HL
 INC HL
;carapace risque de tomber ?
 DEC HL
 LD A,(HL)
 CP 1
 jr Z,teste_a_droite_carapace
;teste_a_gauche_carapace
 INC HL
 LD A,(HL) ;A=x
 ADD A,2
 JR teste_tortue_bas_carapace
teste_a_droite_carapace:
 INC HL
 LD A,(HL) ;A=x
 ADD A,2
teste_tortue_bas_carapace:
 JP P,pas_negatif
 NEG
 SRL A;
 SRL A; A=A/8
 SRL A;
 NEG
 JR fin_pos_neg
pas_negatif:
 SRL A;
 SRL A; A=A/8
 SRL A;
 INC A
fin_pos_neg:
 INC HL
 INC HL
 ADD A,(HL)
 DEC HL
 PUSH HL
 LD C,(HL)
 LD B,0
 SRL C;
 SRL C; C=C/8
 SRL C;
 INC C
 LD HL,(long_de_la_carte)
 CALL MUL_HL_BC
 LD D,0
 LD E,A
 ADD HL,DE
 LD DE,CurMap
 ADD HL,DE
 LD (buffer16_2),HL
 LD A,(HL)
 OR A;CP 0
 JR Z,pas_de_collision_carapace_bas
 CP 41
 JR C,collision_carapace_bas
pas_de_collision_carapace_bas:
 POP HL
 PUSH HL
 LD A,(HL)
 INC A
 LD (HL),A
collision_carapace_bas:
 POP HL
 PUSH HL
 DEC HL
;carapace peut avancer?
 LD HL,(buffer16)
 INC HL
 LD A,(HL)
 OR A
 JR Z,test_gauche_carapace
 LD HL,(buffer16_2)
 LD DE,(long_de_la_carte)
 SBC HL,DE
 INC HL
 JR fin_test_carapace
test_gauche_carapace:
 LD HL,(buffer16_2)
 LD DE,(long_de_la_carte)
 SBC HL,DE
fin_test_carapace:
 LD A,(HL)
 OR A;CP 0
 JR Z,pas_de_collision_carapace_cote
 CP 41
 JR C,collision_carapace_cote
pas_de_collision_carapace_cote:
 POP HL
 DEC HL
;la carapace doit se deplacer  gauche ou  droite?
 PUSH HL
 DEC HL
 LD A,(HL)
 CP 1
 JR Z,vers_droite_carapace
;vers_gauche_carapace
 POP HL
 LD B,(HL) ;B=nombre  ajouter  (colonne*8) pour avoir la coordonne x
 DEC B
 LD (HL),B
 JR affiche_carapace
vers_droite_carapace:
 POP HL
 LD B,(HL) ;B=nombre  ajouter  (colonne*8) pour avoir la coordonne x
 INC B
 LD (HL),B
 JR affiche_carapace
collision_carapace_cote:
;
 POP HL
 DEC HL
;la carapace doit se deplacer  gauche ou  droite?
 PUSH HL
 DEC HL
 LD A,(HL)
 CP 1
 JR Z,met_0_carapace2
;met_1_carapace2
 SET 0,A            ; A = 1
 JR fin_met_carapace2
met_0_carapace2:
 RES 0,A            ; A = 0
fin_met_carapace2:
 LD (HL),A
 POP HL
 INC HL
 PUSH HL
 JR pas_de_collision_carapace_cote
affiche_carapace:
 INC HL
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 LD B,A
 ADD A,8
 CP 8
 JP C,mechant_disparait
 CP 88
 JP NC,mechant_disparait
;collision avec Mario
 PUSH BC
 LD A,B
 SUB 8
 LD B,A
 LD A,(x_mario)
 CP B
 JR C,carapace_est_derriere_m
;carapace est il derrire Mario?
 LD A,B
 ADD A,16
 LD B,A
 LD A,(x_mario)
 CP B
 JR NC,carapace_est_devant_m
 DEC HL
 LD C,(HL)
 INC HL
 LD A,(y_mario)
 SUB 3
 CP C
 JR NC,carapace_ou_mario_pas_mort
 ADD A,10
 CP C
 JR C,carapace_ou_mario_pas_mort
 POP BC
 POP BC ;annule le call
 JP mario_est_mort
carapace_est_devant_m:
carapace_est_derriere_m:
carapace_ou_mario_pas_mort:
 POP BC
 DEC HL
 LD A,(HL)
 ADD A,3
 LD C,A
 LD A,5
 LD DE,carapace
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

;----------------------------------------ETOILE-------------------------------------------
gere_etoile:
 LD (buffer16),HL
 INC HL
 INC HL
 INC HL
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 SUB 10
 LD B,A
 ADD A,8
 CP 8
 JP C,mechant_disparait
 DEC HL
 LD A,(HL)
 INC A
 LD C,A
 LD HL,(buffer16)
 LD DE,6
 ADD HL,DE
 LD A,(HL)
 OR A
 JR Z,timer_etoile_0
;timer_etoile_1
 LD DE,etoile+14
 XOR A
 LD (HL),A
 JR fin_timer_etoile
timer_etoile_0:
 LD DE,etoile
 INC A
 LD (HL),A
fin_timer_etoile:
 LD A,7
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

;----------------------------------------FLEUR-------------------------------------------
gere_fleur:
 LD (buffer16),HL
 INC HL
 INC HL
 LD A,(HL) ;A=x
 ADD A,2
 JP P,pas_negatif_fleur
 NEG
 SRL A;
 SRL A; A=A/8
 SRL A;
 NEG
 JR fin_pos_neg_fleur
pas_negatif_fleur:
 SRL A;
 SRL A; A=A/8
 SRL A;
 INC A
fin_pos_neg_fleur:
 INC HL
 INC HL
 ADD A,(HL)
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 SUB 10
 LD B,A
 ADD A,8
 CP 8
 JP C,mechant_disparait
 DEC HL
 LD A,(HL)
 LD C,A
 LD HL,(buffer16)
 LD DE,6
 ADD HL,DE
 LD A,(HL)
 OR A
 JR Z,timer_fleur_0
;timer_fleur_1
 LD DE,fleur+16
 XOR A
 LD (HL),A
 JR fin_timer_fleur
timer_fleur_0:
 LD DE,fleur
 INC A
 LD (HL),A
fin_timer_fleur:
 LD A,8
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

;----------------------------------------BOULE DE FEU------------------------------------
gere_boule_de_feu:
 LD (buffer16),HL
 INC HL
 INC HL
 PUSH HL
 DEC HL
;HL -> direction
 LD A,(HL)
 INC HL
 INC HL
 CP 1
 JR Z,boule_de_feu_monte
;boule_de_feu_dessent
 LD A,(HL) ; HL -> y
 INC A
 LD (HL),A
;vrifie si la boule_de_feu n'est pas trop bas
 INC HL\ INC HL
 SUB (HL)
 CP 40
 JR NZ,mouvement_boule_de_feu
 DEC HL\ DEC HL\ DEC HL\ DEC HL
 LD A,1
 LD (HL),A
 JR mouvement_boule_de_feu
boule_de_feu_monte:
 LD A,(HL) ; HL -> y
 DEC A
 LD (HL),A
;vrifie si la boule_de_feu n'est pas trop haute
 INC HL\ INC HL
 SUB (HL)
 OR A
 JR NZ,mouvement_boule_de_feu
 DEC HL\ DEC HL\ DEC HL\ DEC HL
 LD A,0
 LD (HL),A
mouvement_boule_de_feu:
 POP HL
 LD B,(HL)
affiche_boule_de_feu:
 INC HL
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 LD B,A
 ADD A,8
 CP 8
 JP C,mechant_disparait
;collision avec Mario
 PUSH BC
 LD A,B
 SUB 8
 LD B,A
 LD A,(x_mario)
 CP B
 JR C,boule_de_feu_est_derriere_m
;boule de feu est il derrire Mario?
 LD A,B
 ADD A,16
 LD B,A
 LD A,(x_mario)
 CP B
 JR NC,boule_de_feu_est_devant_m
 DEC HL
 LD C,(HL)
 INC HL
 LD A,(y_mario)
 SUB 3
 CP C
 JR NC,boule_de_feu_ou_mario_pas_mort
 ADD A,10
 CP C
 JR C,boule_de_feu_ou_mario_pas_mort
 POP BC
 POP BC ;annule le call
 JP mario_est_mort
boule_de_feu_est_devant_m:
boule_de_feu_est_derriere_m:
boule_de_feu_ou_mario_pas_mort:
 POP BC
 DEC HL
 LD A,(HL)
 LD C,A
 LD HL,(buffer16)
 INC HL
 LD A,(HL)
 OR A
 JR Z,aff_boule_de_feu_dessens
;aff_boule_de_feu_monte
 LD DE,boule_de_feu
 JR fin_aff_boule_de_feu
aff_boule_de_feu_dessens:
 LD DE,boule_de_feu+16
fin_aff_boule_de_feu:
 LD A,8
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

;----------------------------------------PIERRE----------------------------------------------
gere_pierre:
 LD (buffer16),HL
 INC HL
 INC HL
 PUSH HL
 DEC HL
;HL -> direction
 LD A,(HL)
 INC HL
 INC HL
 CP 1
 JP Z,pierre_monte
 CP 2
 JR Z,pierre_dessent
;pierre_attend
;il faut que mario passe sous la pierre pour qu'elle tombe
 DEC HL
 LD A,(HL) ;HL -> x
 JP P,pas_negatif_pierre
 NEG
 SRL A;
 SRL A; A=A/8
 SRL A;
 NEG
 JR fin_pos_neg_pierre
pas_negatif_pierre:
 SRL A;
 SRL A; A=A/8
 SRL A;
 INC A
fin_pos_neg_pierre:
 INC HL
 INC HL
 ADD A,(HL) ;HL -> init x
;A = colonne de la pierre
 DEC A
 LD B,A
 LD A,(x_mario)
 PUSH AF
 LD A,(buffer8)
 OR A
 JR Z,buffer8_0_pierre
 CP 1
 JR Z,buffer8_1_pierre
 CP 2
 JR Z,buffer8_2_pierre
;buffer8_3_pierre
 POP AF
 JR fin_buffer8_pierre
buffer8_0_pierre:
 POP AF
 SUB 7
 JR fin_buffer8_pierre
buffer8_1_pierre:
 POP AF
 SUB 4
 JR fin_buffer8_pierre
buffer8_2_pierre:
 POP AF
 SUB 3
fin_buffer8_pierre:
 SRL A;
 SRL A; A=A/8
 SRL A;
 LD C,A
 LD A,(num_colonneb-1)
 ADD A,C
 SUB 8
 CP B
 JR Z,pierre_active
 DEC A
 CP B
 JR Z,pierre_active
 DEC A
 CP B
 JR Z,pierre_active
 JP mouvement_pierre
pierre_active:
 LD A,2
 DEC HL\ DEC HL\ DEC HL
 LD (HL),A
 JP mouvement_pierre
pierre_dessent:
 LD A,(HL) ; HL -> y
 INC A
 LD (HL),A
;vrifie si la pierre n'est pas trop bas
;si il y a collision avec un objet, la pierre remonte
 DEC A
 SRL A;
 SRL A; A=A/8
 SRL A;
 LD B,0
 LD C,A
;C=coordonne y du carr
 LD HL,(long_de_la_carte)
 CALL MUL_HL_BC
 LD DE,CurMap
 ADD HL,DE
;maintenant on calcule la coordonne x du carr
 PUSH HL
 LD HL,(buffer16)
 INC HL\ INC HL
 LD A,(HL) ;HL -> x
 JP P,pas_negatif_pierre2
 NEG
 SRL A;
 SRL A; A=A/8
 SRL A;
 NEG
 JR fin_pos_neg_pierre2
pas_negatif_pierre2:
 SRL A;
 SRL A; A=A/8
 SRL A;
 INC A
fin_pos_neg_pierre2:
 INC HL
 INC HL
 ADD A,(HL) ;HL -> init x
;A = coordonne x du carr
 DEC A
 POP HL
 LD B,0
 LD C,A
 ADD HL,BC
 INC HL\ INC HL\ INC HL
;HL->carr sous la pierre
 LD A,(HL)
 OR A;CP 0
 JR Z,pas_collision_bas_pierre
 CP 69
 JR Z,collision_bas_pierre
 CP 70
 JR Z,collision_bas_pierre
 CP 71
 JR Z,collision_bas_pierre
 CP 41
 JR C,collision_bas_pierre
pas_collision_bas_pierre:
 INC HL
 LD A,(HL)
 OR A;CP 0
 JR Z,mouvement_pierre
 CP 69
 JR Z,collision_bas_pierre
 CP 70
 JR Z,collision_bas_pierre
 CP 71
 JR Z,collision_bas_pierre
 CP 41
 JR C,collision_bas_pierre
 JR mouvement_pierre
collision_bas_pierre:
 LD HL,(buffer16)
 INC HL
 LD A,1
 LD (HL),A
 JR mouvement_pierre
pierre_monte:
 LD A,(HL) ; HL -> y
 DEC A
 LD (HL),A
;vrifie si la pierre n'est pas trop haute
 INC HL\ INC HL
 SUB (HL)
 OR A
 JR NZ,mouvement_pierre
 DEC HL\ DEC HL\ DEC HL\ DEC HL
 XOR A
 LD (HL),A
mouvement_pierre:
 POP HL
 LD B,(HL)
affiche_pierre:
 INC HL
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 SUB 8
 LD B,A
 ADD A,8
 CP 8
 JP C,mechant_disparait
 DEC HL
 LD A,(HL)
 SUB 8
 LD C,A
 LD A,16
 LD DE,pierre
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 PUSH BC
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 POP BC
 LD A,B
 ADD A,8
 LD B,A
 LD DE,pierre+32
 LD A,16
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

;----------------------------------------TORTUE VOLANTE------------------------------------
gere_tortue_volante:
 LD (buffer16),HL
 INC HL
 INC HL
;dplace tortue_volante
 PUSH HL
 LD BC,4
 ADD HL,BC
 LD A,(HL)
 CP 2
 JR NC,attend_un_peu_tortue_volante
 INC A
 LD (HL),A
 POP HL
 LD B,(HL)
 JR affiche_tortue_volante
attend_un_peu_tortue_volante:
 XOR A
 LD (HL),A
 POP HL
 PUSH HL
 DEC HL
;HL -> direction
 LD A,(HL)
 INC HL
 INC HL
 CP 1
 JR Z,tortue_volante_monte
 CP %10000001
 JR Z,tortue_volante_monte
;tortue_volante_dessent
 LD A,(HL) ; HL -> y
 INC A
 LD (HL),A
;vrifie si la tortue_volante n'est pas trop bas
 INC HL\ INC HL
 SUB (HL)
 CP 24
 JR NZ,mouvement_tortue_volante
 DEC HL\ DEC HL\ DEC HL\ DEC HL
 LD A,(HL)
 INC A
 LD (HL),A
 JR mouvement_tortue_volante
tortue_volante_monte:
 LD A,(HL) ; HL -> y
 DEC A
 LD (HL),A
;vrifie si la tortue_volante n'est pas trop haute
 INC HL\ INC HL
 SUB (HL)
 OR A
 JR NZ,mouvement_tortue_volante
 DEC HL\ DEC HL\ DEC HL\ DEC HL
 LD A,(HL)
 DEC A
 LD (HL),A
mouvement_tortue_volante:
 POP HL
 LD B,(HL)
affiche_tortue_volante:
 INC HL
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 LD B,A
 ADD A,8
 CP 8
 JP C,mechant_disparait
 DEC HL
 LD A,(HL)
 CP 55
 JR NC,n_affiche_pas_tortue_vol
 SUB 4
 LD C,A
 LD HL,(buffer16)
 INC HL
 LD A,(HL)
 XOR %10000000
 JP M,aff_tortue_volante_1
;aff_tortue_volante_2
 LD DE,tortue_volante
 JR fin_aff_tortue_volante
aff_tortue_volante_1:
 LD DE,tortue_volante+24
fin_aff_tortue_volante:
 LD (HL),A
 LD A,12
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
n_affiche_pas_tortue_vol:
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

;----------------------------------------CHAMPIGNON---------------------------------------------
gere_champignon:
 LD (buffer16),HL
 INC HL
 INC HL
;dplace champignon
 PUSH HL
 LD BC,4
 ADD HL,BC
 LD A,(HL)
 CP 2
 JR NC,attend_un_peu_champignon
 INC A
 LD (HL),A
 POP HL
 LD B,(HL)
 JP affiche_champignon
attend_un_peu_champignon:
 XOR A
 LD (HL),A
 POP HL
;champignon risque de tomber ?
 DEC HL
 LD A,(HL)
 CP 1
 jr Z,teste_a_droite_champignon
;teste_a_gauche_champignon
 INC HL
 LD A,(HL) ;A=x
 ADD A,2
 JR teste_tortue_bas_champignon
teste_a_droite_champignon:
 INC HL
 LD A,(HL) ;A=x
 ADD A,2
teste_tortue_bas_champignon:
 JP P,pas_negatif_champignon
 NEG
 SRL A;
 SRL A; A=A/8
 SRL A;
 NEG
 JR fin_pos_neg_champignon
pas_negatif_champignon:
 SRL A;
 SRL A; A=A/8
 SRL A;
 INC A
fin_pos_neg_champignon:
 INC HL
 INC HL
 ADD A,(HL)
 DEC HL
 PUSH HL
 LD C,(HL)
 LD B,0
 SRL C;
 SRL C; C=C/8
 SRL C;
 INC C
 LD HL,(long_de_la_carte)
 CALL MUL_HL_BC
 LD D,0
 LD E,A
 ADD HL,DE
 LD DE,CurMap
 ADD HL,DE
 LD (buffer16_2),HL
 LD A,(HL)
 OR A;CP 0
 JR Z,pas_de_collision_champignon_bas
 CP 41
 JR C,collision_champignon_bas
pas_de_collision_champignon_bas:
 POP HL
 PUSH HL
 LD A,(HL)
 INC A
 LD (HL),A
collision_champignon_bas:
 POP HL
 PUSH HL
 DEC HL
;champignon peut avancer?
 LD HL,(buffer16)
 INC HL
 LD A,(HL)
 OR A
 JR Z,test_gauche_champignon
 LD HL,(buffer16_2)
 LD DE,(long_de_la_carte)
 SBC HL,DE
 INC HL
 JR fin_test_champignon
test_gauche_champignon:
 LD HL,(buffer16_2)
 LD DE,(long_de_la_carte)
 SBC HL,DE
fin_test_champignon:
 LD A,(HL)
 OR A;CP 0
 JR Z,pas_de_collision_champ_cote
 CP 41
 JR C,collision_champignon_cote
pas_de_collision_champ_cote:
 POP HL
 DEC HL
;champignon doit se deplacer  gauche ou  droite?
 PUSH HL
 DEC HL
 LD A,(HL)
 CP 1
 JR Z,vers_droite_champignon
;vers_gauche_champignon
 POP HL
 LD B,(HL) ;B=nombre  ajouter  (colonne*8) pour avoir la coordonne x
 DEC B
 LD (HL),B
 JR affiche_champignon
vers_droite_champignon:
 POP HL
 LD B,(HL) ;B=nombre  ajouter  (colonne*8) pour avoir la coordonne x
 INC B
 LD (HL),B
 JR affiche_champignon
collision_champignon_cote:
;
 POP HL
 DEC HL
;champignon doit se deplacer  gauche ou  droite?
 PUSH HL
 DEC HL
 LD A,(HL)
 CP 1
 JR Z,met_0_champignon2
;met_1_champignon2
 SET 0,A            ; A = 1
 JR fin_met_champignon2
met_0_champignon2:
 RES 0,A            ; A = 0
fin_met_champignon2:
 LD (HL),A
 POP HL
 INC HL
 PUSH HL
 JR pas_de_collision_champ_cote
affiche_champignon:
 INC HL
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 LD B,A
 ADD A,8
 CP 8
 JP C,mechant_disparait
 CP 88
 JP NC,affiche_pas_champ






;collision avec Mario
 PUSH BC
 LD A,B
 SUB 8
 LD B,A
 LD A,(x_mario)
 CP B
 JR C,champ_est_derriere_m
;champ est il derrire Mario?
 LD A,B
 ADD A,16
 LD B,A
 LD A,(x_mario)
 CP B
 JR NC,champ_est_devant_m
 DEC HL
 LD C,(HL)
 INC HL
 LD A,(y_mario)
 ADD A,3
 CP C
 JR NC,champ_ou_mario_pas_mort
 ADD A,7
 CP C
 JR C,champ_ou_mario_pas_mort
 POP BC
 LD A,2
 LD (mario_transformation),A
 JP mechant_disparait
champ_est_devant_m:
champ_est_derriere_m:
champ_ou_mario_pas_mort:
 POP BC










 DEC HL
 LD A,(HL)
 LD C,A
 LD A,8
 LD DE,champignon
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
affiche_pas_champ:
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

;----------------------------------------CHAMPIGNON NOIR---------------------------------------------
gere_champignon_noir:
 LD (buffer16),HL
 INC HL
 INC HL
;dplace champignon_noir
 PUSH HL
 LD BC,4
 ADD HL,BC
 LD A,(HL)
 CP 2
 JR NC,attend_un_peu_champignon_noir
 INC A
 LD (HL),A
 POP HL
 LD B,(HL)
 JP affiche_champignon_noir
attend_un_peu_champignon_noir:
 XOR A
 LD (HL),A
 POP HL
;champignon_noir risque de tomber ?
 DEC HL
 LD A,(HL)
 CP 1
 jr Z,teste_a_droite_champignon_noir
;teste_a_gauche_champignon_noir
 INC HL
 LD A,(HL) ;A=x
 ADD A,2
 JR teste_tortue_bas_champ_noir
teste_a_droite_champignon_noir:
 INC HL
 LD A,(HL) ;A=x
 ADD A,2
teste_tortue_bas_champ_noir:
 JP P,pas_negatif_champignon_noir
 NEG
 SRL A;
 SRL A; A=A/8
 SRL A;
 NEG
 JR fin_pos_neg_champignon_noir
pas_negatif_champignon_noir:
 SRL A;
 SRL A; A=A/8
 SRL A;
 INC A
fin_pos_neg_champignon_noir:
 INC HL
 INC HL
 ADD A,(HL)
 DEC HL
 PUSH HL
 LD C,(HL)
 LD B,0
 SRL C;
 SRL C; C=C/8
 SRL C;
 INC C
 LD HL,(long_de_la_carte)
 CALL MUL_HL_BC
 LD D,0
 LD E,A
 ADD HL,DE
 LD DE,CurMap
 ADD HL,DE
 LD (buffer16_2),HL
 LD A,(HL)
 OR A;CP 0
 JR Z,pas_de_collision_champ_n_bas
 CP 41
 JR C,collision_champignon_noir_bas
pas_de_collision_champ_n_bas:
 POP HL
 PUSH HL
 LD A,(HL)
 INC A
 LD (HL),A
collision_champignon_noir_bas:
 POP HL
 PUSH HL
 DEC HL
;champignon_noir peut avancer?
 LD HL,(buffer16)
 INC HL
 LD A,(HL)
 OR A
 JR Z,test_gauche_champignon_noir
 LD HL,(buffer16_2)
 LD DE,(long_de_la_carte)
 SBC HL,DE
 INC HL
 JR fin_test_champignon_noir
test_gauche_champignon_noir:
 LD HL,(buffer16_2)
 LD DE,(long_de_la_carte)
 SBC HL,DE
fin_test_champignon_noir:
 LD A,(HL)
 OR A;CP 0
 JR Z,pas_de_collision_champ_n_cote
 CP 41
 JR C,collision_champignon_noir_cote
pas_de_collision_champ_n_cote:
 POP HL
 DEC HL
;champignon_noir doit se deplacer  gauche ou  droite?
 PUSH HL
 DEC HL
 LD A,(HL)
 CP 1
 JR Z,vers_droite_champignon_noir
;vers_gauche_champignon_noir
 POP HL
 LD B,(HL) ;B=nombre  ajouter  (colonne*8) pour avoir la coordonne x
 DEC B
 LD (HL),B
 JR affiche_champignon_noir
vers_droite_champignon_noir:
 POP HL
 LD B,(HL) ;B=nombre  ajouter  (colonne*8) pour avoir la coordonne x
 INC B
 LD (HL),B
 JR affiche_champignon_noir
collision_champignon_noir_cote:
;
 POP HL
 DEC HL
;champignon_noir doit se deplacer  gauche ou  droite?
 PUSH HL
 DEC HL
 LD A,(HL)
 CP 1
 JR Z,met_0_champignon_noir2
;met_1_champignon_noir2
 SET 0,A            ; A = 1
 JR fin_met_champignon_noir2
met_0_champignon_noir2:
 RES 0,A            ; A = 0
fin_met_champignon_noir2:
 LD (HL),A
 POP HL
 INC HL
 PUSH HL
 JR pas_de_collision_champ_n_cote
affiche_champignon_noir:
 INC HL
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 LD B,A
 ADD A,8
 CP 8
 JP C,mechant_disparait
 DEC HL
 LD A,(HL)
 LD C,A
 LD A,8
 LD DE,champignon_noir
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

;----------------------------------------BOULE DE CANON HAUT GAUCHE-------------------------------------------
gere_bdchg:
 LD (buffer16),HL
 INC HL
 INC HL
;dplace bdchg
 PUSH HL
 LD BC,4
 ADD HL,BC
 LD A,(HL)
 CP 2
 JR NC,attend_un_peu_bdchg
 INC A
 LD (HL),A
 POP HL
 LD B,(HL)
 JR affiche_bdchg
attend_un_peu_bdchg:
 XOR A
 LD (HL),A
 POP HL
 INC HL
 LD A,(HL)
 DEC A
 LD (HL),A ;A=y
 DEC HL
 LD B,(HL) ;B=nombre  ajouter  (colonne*8) pour avoir la coordonne x
 DEC B
 LD (HL),B
affiche_bdchg:
 INC HL
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 LD B,A
 ADD A,8
 CP 8
 JP NC,p_retire_un_bdchg
 DEC HL
 DEC HL
 LD A,(HL)
 INC HL
 INC HL
 CP -10
 JP Z,mechant_disparait
 DEC HL
 INC HL
 INC HL
 LD A,(HL)
 DEC HL
 DEC HL
 LD (HL),A ;y=init y
 DEC HL
 LD (HL),-10
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres
p_retire_un_bdchg:
 DEC HL
 LD A,(HL)
 CP 1
 JP NC,p_retire_un_bdchg2
 INC HL
 INC HL
 LD A,(HL)
 DEC HL
 DEC HL
 LD (HL),A ;y=init y
 DEC HL
 LD (HL),-10
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres
p_retire_un_bdchg2:
 LD C,A
 LD A,8
 LD DE,boule_de_canon
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

;----------------------------------------BOULE DE CANON BAS GAUCHE-------------------------------------------
gere_bdcbg:
 LD (buffer16),HL
 INC HL
 INC HL
;dplace bdcbg
 PUSH HL
 LD BC,4
 ADD HL,BC
 LD A,(HL)
 CP 2
 JR NC,attend_un_peu_bdcbg
 INC A
 LD (HL),A
 POP HL
 LD B,(HL)
 JR affiche_bdcbg
attend_un_peu_bdcbg:
 XOR A
 LD (HL),A
 POP HL
 INC HL
 LD A,(HL)
 INC A
 LD (HL),A ;A=y
 DEC HL
 LD B,(HL) ;B=nombre  ajouter  (colonne*8) pour avoir la coordonne x
 DEC B
 LD (HL),B
affiche_bdcbg:
 INC HL
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 LD B,A
 ADD A,8
 CP 8
 JP NC,p_retire_un_bdcbg
 DEC HL
 DEC HL
 LD A,(HL)
 INC HL
 INC HL
 CP -10
 JP Z,mechant_disparait
 DEC HL
 INC HL
 INC HL
 LD A,(HL)
 DEC HL
 DEC HL
 LD (HL),A ;y=init y
 DEC HL
 LD (HL),-10
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres
p_retire_un_bdcbg:
 DEC HL
 LD A,(HL)
 CP 55
 JP C,p_retire_un_bdcbg2
 INC HL
 INC HL
 LD A,(HL)
 DEC HL
 DEC HL
 LD (HL),A ;y=init y
 DEC HL
 LD (HL),-10
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres
p_retire_un_bdcbg2:
 LD C,A
 LD A,8
 LD DE,boule_de_canon
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

;----------------------------------------BOULE DE FEU PLANTE-------------------------------------------
gere_boule_de_feu_plante:
 LD (buffer16),HL
 INC HL
 INC HL
;dplace boule_de_feu_plante
 PUSH HL
 LD BC,4
 ADD HL,BC
 LD A,(HL)
 CP 2
 JR NC,attend_un_peu_b_de_feu_plante
 INC A
 LD (HL),A
 POP HL
 LD B,(HL)
 JR affiche_boule_de_feu_plante
attend_un_peu_b_de_feu_plante:
 XOR A
 LD (HL),A
 POP HL
 INC HL
 LD A,(HL)
 DEC A
 LD (HL),A ;A=y
 DEC HL
 LD B,(HL) ;B=nombre  ajouter  (colonne*8) pour avoir la coordonne x
 DEC B
 LD (HL),B
affiche_boule_de_feu_plante:
 INC HL
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 LD B,A
 ADD A,8
 CP 8
 JP C,mechant_disparait
 DEC HL
 LD A,(HL)
 INC HL
 CP 1
 JP C,mechant_disparait
 LD C,A
 LD A,3
 LD DE,petite_boule_de_feu
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

;----------------------------------------BOWSER------------------------------------
gere_bowser:
 LD (buffer16),HL
 INC HL
 INC HL
 PUSH HL
 DEC HL
;HL -> direction
 LD A,(HL)
 INC HL
 INC HL
 CP 1
 JP Z,bowser_monte
 CP %10000001
 JP Z,bowser_monte
;bowser_dessent
 LD A,(HL) ; HL -> y
 INC A
 LD (HL),A
;vrifie si bowser n'est pas trop bas
;si il y a collision avec un objet, la bowser remonte
 CALL HL_point_carre
;HL->carr sous bowser
 LD (buffer16_2),HL
 LD A,(HL)
 OR A;CP 0
 JR Z,pas_collision_bas_bowser
 CP 69
 JR Z,collision_bas_bowser
 CP 70
 JR Z,collision_bas_bowser
 CP 71
 JR Z,collision_bas_bowser
 CP 41
 JR C,collision_bas_bowser
pas_collision_bas_bowser:
 INC HL
 LD A,(HL)
 OR A;CP 0
 JR Z,mouvement_bowser
 CP 69
 JR Z,collision_bas_bowser
 CP 70
 JR Z,collision_bas_bowser
 CP 71
 JR Z,collision_bas_bowser
 CP 41
 JR C,collision_bas_bowser
 JR mouvement_bowser
collision_bas_bowser:
 LD HL,(buffer16)
 INC HL
 LD A,(HL)
 INC A
 LD (HL),A
 JR mouvement_bowser
bowser_monte:
 LD A,(HL) ; HL -> y
 DEC A
 LD (HL),A
;vrifie si bowser n'est pas trop haut
 PUSH HL
 CALL HL_point_carre
;HL->carr sous bowser
 LD (buffer16_2),HL
 LD DE,(long_de_la_carte)
 SBC HL,DE
 SBC HL,DE
 SBC HL,DE
 LD A,(HL)
 OR A;CP 0
 JR Z,pas_collision_haut_bowser
 CP 69
 JR Z,collision_haut_bowser
 CP 70
 JR Z,collision_haut_bowser
 CP 71
 JR Z,collision_haut_bowser
 CP 41
 JR C,collision_haut_bowser
pas_collision_haut_bowser:
 INC HL
 LD A,(HL)
 OR A;CP 0
 JR Z,mouvement_bowser3
 CP 69
 JR Z,collision_haut_bowser
 CP 70
 JR Z,collision_haut_bowser
 CP 71
 JR Z,collision_haut_bowser
 CP 41
 JR C,collision_haut_bowser
 JR mouvement_bowser3
collision_haut_bowser:
 LD HL,(buffer16)
 INC HL
 LD A,(HL)
 DEC A
 LD (HL),A
mouvement_bowser3:
 POP HL
;vrifie si bowser n'est pas plus haut que la zonz o il vient d'apparaitre
 INC HL\ INC HL
 SUB (HL)
 OR A
 JR NZ,mouvement_bowser
 DEC HL\ DEC HL\ DEC HL\ DEC HL
 LD A,(HL)
 DEC A
 LD (HL),A
mouvement_bowser:
;collision cots
 LD HL,(buffer16_2)
 LD DE,(long_de_la_carte)
 SBC HL,DE
 DEC HL
 LD A,(HL)
 OR A;CP 0
 JR Z,mouvement_bowser2
 CP 69
 JR Z,collision_gauche_bowser
 CP 70
 JR Z,collision_gauche_bowser
 CP 71
 JR Z,collision_gauche_bowser
 CP 41
 JR C,collision_gauche_bowser
 INC HL
 INC HL
 INC HL
 LD A,(HL)
 OR A;CP 0
 JR Z,mouvement_bowser2
 CP 69
 JR Z,collision_droite_bowser
 CP 70
 JR Z,collision_droite_bowser
 CP 71
 JR Z,collision_droite_bowser
 CP 41
 JR C,collision_droite_bowser
 SBC HL,DE
 LD A,(HL)
 OR A;CP 0
 JR Z,mouvement_bowser2
 CP 69
 JR Z,collision_droite_bowser
 CP 70
 JR Z,collision_droite_bowser
 CP 71
 JR Z,collision_droite_bowser
 CP 41
 JR C,collision_droite_bowser
 DEC HL
 DEC HL
 DEC HL
 LD A,(HL)
 OR A;CP 0
 JR Z,mouvement_bowser2
 CP 69
 JR Z,collision_gauche_bowser
 CP 70
 JR Z,collision_gauche_bowser
 CP 71
 JR Z,collision_gauche_bowser
 CP 41
 JR C,collision_gauche_bowser
 JR mouvement_bowser2
collision_gauche_bowser:
 LD HL,(buffer16)
 INC HL
 LD A,(HL)
 OR %10000000
 LD (HL),A
 JR mouvement_bowser2
collision_droite_bowser:
 LD HL,(buffer16)
 INC HL
 LD A,(HL)
 XOR %10000000
 LD (HL),A
mouvement_bowser2:
;bowser doit se deplacer  gauche ou  droite
 LD HL,(buffer16)
 INC HL
 LD A,(HL)
 OR A
 JP M,bowser_droite
;bowser_gauche
 POP HL
 PUSH HL
 DEC (HL)
 JR fin_bowser
bowser_droite:
 POP HL
 PUSH HL
 INC (HL)
fin_bowser:
 POP HL
 LD B,(HL)
affiche_bowser:
 INC HL
 INC HL
 LD C,(HL) ;C=colonne o est apparu le monstre
 LD A,(num_colonneb-1)
 SUB C
 ADD A,A ;
 ADD A,A ; A=A*8
 ADD A,A ;
 LD C,A
 LD A,80
 SUB C
 ADD A,B
 LD B,A
 LD A,(buffer8)
 ADD A,A
 LD C,A
 LD A,B
 SUB C
 SUB 8
 LD B,A
 ADD A,8
 CP 10
 JR C,change_de_sens_vers_droite
 CP 72
 JR NC,change_de_sens_vers_gauche
 JR p_change_de_sens
change_de_sens_vers_droite:
 PUSH HL
 LD HL,(buffer16)
 INC HL
 LD A,(HL)
 OR %10000000
 LD (HL),A
 INC HL
 INC (HL)
 POP HL
 JR p_change_de_sens
change_de_sens_vers_gauche:
 PUSH HL
 LD HL,(buffer16)
 INC HL
 LD A,(HL)
 XOR %10000000
 LD (HL),A
 POP HL
p_change_de_sens:
 DEC HL
 LD A,(HL)
 LD C,A
 LD A,20
 LD DE,bowser
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 PUSH BC
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 POP BC
 LD A,B
 ADD A,8
 LD B,A
 LD DE,bowser+40
 LD A,20
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

HL_point_carre:
 ADD A,4
 SRL A;
 SRL A; A=A/8
 SRL A;
 INC A
 INC A
 LD B,0
 LD C,A
;C=coordonne y de bowser
 LD HL,(long_de_la_carte)
 CALL MUL_HL_BC
 LD DE,CurMap
 ADD HL,DE
;maintenant on calcule la coordonne x du bowser
 PUSH HL
 LD HL,(buffer16)
 INC HL\ INC HL
 LD A,(HL) ;HL -> x
 OR A
 JP M,negatif_bowser2
 SRL A;
 SRL A; A=A/8
 SRL A;
 INC A
 JR fin_pos_neg_bowser2
negatif_bowser2:
 NEG
 SRL A;
 SRL A; A=A/8
 SRL A;
 NEG
fin_pos_neg_bowser2:
 INC HL
 INC HL
 ADD A,(HL) ;HL -> init x
;A = coordonne x du carr
 INC A
 POP HL
 LD B,0
 LD C,A
 ADD HL,BC
 DEC HL
 RET

;-------------------------------------------------------------------------------------------

;entree: HL=place du nouvel ennemis
;sortie: HL=zone de 7 octet libre
insere_ennemis:
 LD DE,ennemis_affiches+224
 EX DE,HL
 SBC HL,DE
 LD B,H
 LD C,L
 INC BC
 LD HL,ennemis_affiches+217
 LD DE,ennemis_affiches+224
 LDDR
 INC HL
 RET

mechant_disparait:
 XOR A
 LD (long_sprite_affich),A
 LD BC,4
 SBC HL,BC
 EX DE,HL
 LD HL,ennemis_affiches+225
 SBC HL,DE
 LD B,H
 LD C,L
 PUSH BC
 LD HL,7
 ADD HL,DE
 POP BC
 LDIR
 LD HL,(pointeur_ennemis_affiches)
 LD BC,7
 SBC HL,BC
 LD (pointeur_ennemis_affiches),HL
 LD HL,(buffer16)
 JP il_y_a_encore_des_monstres

charge_nouv_e_a_afficher0:
 LD A,(forvary)
 JR continue_charge_nouv_e_a_aff
charge_nouv_e_a_afficher:
;on cherche si dans la nouvelle colonne  afficher il y a un ennemis
 LD A,(num_colonneb-1)
continue_charge_nouv_e_a_aff:
 INC A
 LD B,A
 LD HL,CurEnemyTable+1
cherche_colonne:
 LD A,(HL)
 CP B
 JR Z,col_sup_ou_egal_a_col_ennemis
 RET NC
 INC HL
 INC HL
 INC HL
 LD DE,CurEnemyTable+300
 CALL CP_HL_DE
 RET NC ;on arrete si HL sort de CurEnemyTable
 JR cherche_colonne
col_sup_ou_egal_a_col_ennemis:
;ici on est sur que c'est un nouvel ennemis
 DEC HL
 LD DE,(pointeur_ennemis_affiches)
;HL=ennemis dans CurEnemyTable
;DE=place pour le nouvel ennemis dans ennemis_affiches
 PUSH HL
 INC HL\ INC HL\ INC HL\ INC HL
 LD (cherche_colonne-2),HL ;ne teste plus cet ennemis
 POP HL
 LDI ;type
 XOR A
 LD (DE),A ;direction
 INC DE
 LD A,(HL)
 LD B,A
 LD A,-10
 LD (DE),A ; x
 LD A,B
 INC DE
 INC DE
 LD (DE),A ; init x
 DEC DE
 INC HL
 LDI       ;y
 INC DE
 DEC HL
 LD A,(HL)
 LD (DE),A ;init y
 INC DE
 XOR A
 LD (DE),A ; timer
 INC DE
 LD (pointeur_ennemis_affiches),DE
 INC HL
 INC HL
 JR cherche_colonne

goomba:
;clair
 .DB %00111100
 .DB %01111110
 .DB %11011011
 .DB %11011011
 .DB %11111111
 .DB %00111100
 .DB %01111110
 .DB %01100110
;fonc
 .DB %00111100
 .DB %01111110
 .DB %11011011
 .DB %11011011
 .DB %11111111
 .DB %00000000
 .DB %01000110
 .DB %01100110

goomba_ecrase:
;clair
 .DB %00111100
 .DB %01111110
;fonc
 .DB %00111100
 .DB %01111110

tortue:
;gauche
;clair
 .DB %01100000
 .DB %10010000
 .DB %11010000
 .DB %11010000
 .DB %10010000
 .DB %11101000
 .DB %00111110
 .DB %00111101
 .DB %01111111
 .DB %00011111
 .DB %00011110
 .DB %00110111
;fonc
 .DB %01100000
 .DB %10010000
 .DB %11010000
 .DB %11010000
 .DB %10010000
 .DB %11100000
 .DB %00101110
 .DB %00101101
 .DB %01101111
 .DB %00000110
 .DB %00010000
 .DB %00110111
;droite
;clair
 .DB %00000110
 .DB %00001001
 .DB %00001011
 .DB %00001011
 .DB %00001001
 .DB %00010111
 .DB %01111100
 .DB %10111100
 .DB %11111110
 .DB %11111000
 .DB %01111000
 .DB %11101100
;fonc
 .DB %00000110
 .DB %00001001
 .DB %00001011
 .DB %00001011
 .DB %00001001
 .DB %00000111
 .DB %01110100
 .DB %10110100
 .DB %11110110
 .DB %01100000
 .DB %00001000
 .DB %11101100

missile:
;clair
 .DB %00001111
 .DB %00111110
 .DB %01011111
 .DB %11111110
 .DB %11110110
 .DB %01001111
 .DB %00111110
 .DB %00001111
;fonc
 .DB %00001111
 .DB %00111110
 .DB %01011111
 .DB %11111110
 .DB %11110110
 .DB %01001111
 .DB %00111110
 .DB %00001111

plante:
;clair
 .DB %01000010
 .DB %11000011
 .DB %10100101
 .DB %01011010
 .DB %11100111
 .DB %11111111
 .DB %01111110
 .DB %00111100
 .DB %11011011
 .DB %11111111
 .DB %01111110
 .DB %00111100
 .DB 0
;fonc
 .DB %01000010
 .DB %11000011
 .DB %10100101
 .DB %01011010
 .DB %10100101
 .DB %10011001
 .DB %01000010
 .DB %00111100
 .DB %11011011
 .DB %10111101
 .DB %01011010
 .DB %00111100
 .DB 0

barre_de_fin:
;clair1
 .DB %01111111
 .DB %10000000
 .DB %11111111
 .DB %01111111
;fonc1
 .DB %01111111
 .DB %10000000
 .DB %10000000
 .DB %01111111
;clair2
 .DB %11110000
 .DB %00000000
 .DB %11110000
 .DB %11110000
;fonc2
 .DB %11110000
 .DB %00000000
 .DB %00000000
 .DB %11110000

barre:
;clair
 .DB %11111111
 .DB %10000001
 .DB %01111110
;fonc
 .DB %11111111
 .DB %11111111
 .DB %01111110

poisson:
;normal
;clair
 .DB %00011100
 .DB %00111001
 .DB %01111011
 .DB %10111110
 .DB %01111110
 .DB %01111110
 .DB %11110011
 .DB %00111000
;fonc
 .DB %00011100
 .DB %00111001
 .DB %01111011
 .DB %10111110
 .DB %01111110
 .DB %01111110
 .DB %11110011
 .DB %00111000
;noirci
;clair
 .DB %00000000
 .DB %00111000
 .DB %01110011
 .DB %10111111
 .DB %11111100
 .DB %11111111
 .DB %01100011
 .DB %00110000
;fonc
 .DB %00000000
 .DB %00111000
 .DB %01110011
 .DB %10111111
 .DB %11111100
 .DB %11111111
 .DB %01100011
 .DB %00110000

carapace:
;clair
 .DB %00111100
 .DB %01000110
 .DB %10100001
 .DB %10001001
 .DB %01111110
;fonc
 .DB %00111100
 .DB %01111010
 .DB %11011111
 .DB %11110111
 .DB %01111110

etoile:
;normale
;clair
.DB %00000000
.DB %00011000
.DB %00111100
.DB %01101010
.DB %00111100
.DB %01100110
.DB %00000000
;fonc
.DB %00011000
.DB %00100100
.DB %11000011
.DB %10010101
.DB %01000010
.DB %10011001
.DB %11100111
;noircie
;clair
.DB 0,0,0,0,0,0,0
;fonc
.DB %00011000
.DB %00111100
.DB %11111111
.DB %11111111
.DB %01111110
.DB %11111111
.DB %11100111

fleur:
;normal
;clair
 .DB %00000000
 .DB %00111000
 .DB %00000000
 .DB %00000000
 .DB %00000000
 .DB %00000000
 .DB %00000000
 .DB %00000000
;fonc
 .DB %01111100
 .DB %11111110
 .DB %11111110
 .DB %01111100
 .DB %00010000
 .DB %11010110
 .DB %01111100
 .DB %00111000
;noirci
;clair
 .DB %01111100
 .DB %11000110
 .DB %11111110
 .DB %01111100
 .DB %00010000
 .DB %11010110
 .DB %01111100
 .DB %00111000
;fonc
 .DB %01111100
 .DB %11000110
 .DB %11111110
 .DB %01111100
 .DB %00010000
 .DB %11010110
 .DB %01111100
 .DB %00111000

boule_de_feu:
;monte
;clair
 .DB %00111100
 .DB %01011010
 .DB %10111101
 .DB %10011001
 .DB %10000001
 .DB %01000010
 .DB %00100100
 .DB %00011000
;fonc
 .DB %00111100
 .DB %01100110
 .DB %11000011
 .DB %11100111
 .DB %11111111
 .DB %01111110
 .DB %00111100
 .DB %00011000
;dessens
;clair
 .DB %00011000
 .DB %00100100
 .DB %01000010
 .DB %10000001
 .DB %10011001
 .DB %10111101
 .DB %01011010
 .DB %00111100
;fonc
 .DB %00011000
 .DB %00111100
 .DB %01111110
 .DB %11111111
 .DB %11100111
 .DB %11000011
 .DB %01100110
 .DB %00111100

pierre:
;gauche
;clair
 .DB %01111011
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %01111011
;fonc
 .DB %01111011
 .DB %10100110
 .DB %10010100
 .DB %10001100
 .DB %11001111
 .DB %11111001
 .DB %10101110
 .DB %10100110
 .DB %11100000
 .DB %10100011
 .DB %10100100
 .DB %11110000
 .DB %10111111
 .DB %10010100
 .DB %10100110
 .DB %01111011
;droite
;clair
 .DB %11011110
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %11011110
;fonc
 .DB %11011110
 .DB %01100101
 .DB %00101001
 .DB %00110001
 .DB %11110011
 .DB %10011111
 .DB %01110101
 .DB %01100101
 .DB %00000111
 .DB %11000101
 .DB %00100101
 .DB %00001111
 .DB %11111101
 .DB %00101001
 .DB %01100101
 .DB %11011110

tortue_volante:
;aile vers le haut
;clair
 .DB %01100000
 .DB %10010000
 .DB %11010000
 .DB %11010010
 .DB %10010101
 .DB %11101001
 .DB %00110001
 .DB %00110010
 .DB %01111100
 .DB %00011110
 .DB %00011110
 .DB %00110111
;fonc
 .DB %01100000
 .DB %10010000
 .DB %11010000
 .DB %11010010
 .DB %10010101
 .DB %11101011
 .DB %00110001
 .DB %00110010
 .DB %01111100
 .DB %00000110
 .DB %00010000
 .DB %00110111
;aile vers le bas
;clair
 .DB %01100000
 .DB %10010000
 .DB %11010000
 .DB %11010000
 .DB %10010000
 .DB %11101000
 .DB %00111100
 .DB %00110010
 .DB %01110001
 .DB %00011001
 .DB %00011101
 .DB %00110010
;fonc
 .DB %01100000
 .DB %10010000
 .DB %11010000
 .DB %11010000
 .DB %10010000
 .DB %11100000
 .DB %00111100
 .DB %00110010
 .DB %01110001
 .DB %00001011
 .DB %00010101
 .DB %00110010

champignon:
;clair
 .DB %00111100
 .DB %01000010
 .DB %10000001
 .DB %10000001
 .DB %11111111
 .DB %01010110
 .DB %01000010
 .DB %00111100
;fonc
 .DB %00111100
 .DB %01111110
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %01010110
 .DB %01000010
 .DB %00111100

champignon_noir:
;clair
 .DB %00111100
 .DB %01111110
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %01010110
 .DB %01000010
 .DB %00111100
;fonc
 .DB %00111100
 .DB %01111110
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %01010110
 .DB %01000010
 .DB %00111100

boule_de_canon:
;clair
 .DB %00111100
 .DB %01111110
 .DB %11111011
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %01111110
 .DB %00111100
;fonc
 .DB %00111100
 .DB %01111110
 .DB %11111011
 .DB %11111111
 .DB %11111111
 .DB %11111111
 .DB %01111110
 .DB %00111100

petite_boule_de_feu:
;clair
 .DB %01000000
 .DB %11100000
 .DB %01000000
;fonc
 .DB %01000000
 .DB %10100000
 .DB %01000000

bowser:
;gauche
;clair
 .DB %00010000
 .DB %00110000
 .DB %01010111
 .DB %01011011
 .DB %01011101
 .DB %00111001
 .DB %00111011
 .DB %01011110
 .DB %11111000
 .DB %10110111
 .DB %11001010
 .DB %11010111
 .DB %10111000
 .DB %01100111
 .DB %01110000
 .DB %01101111
 .DB %00110000
 .DB %01111001
 .DB %01111110
 .DB %00111100
;fonc
 .DB %00010000
 .DB %00110000
 .DB %01010111
 .DB %01011011
 .DB %01011101
 .DB %00111001
 .DB %00111011
 .DB %01011110
 .DB %11111000
 .DB %10110111
 .DB %11001010
 .DB %11010111
 .DB %10111000
 .DB %01100111
 .DB %01110000
 .DB %01101111
 .DB %00110000
 .DB %01111001
 .DB %01111110
 .DB %00111100
;droite
;clair
 .DB %00001000
 .DB %00001100
 .DB %11101010
 .DB %11011010
 .DB %10111010
 .DB %10011100
 .DB %11011100
 .DB %01111010
 .DB %00011111
 .DB %11101101
 .DB %01010011
 .DB %11101011
 .DB %00011101
 .DB %11100110
 .DB %00001110
 .DB %11110110
 .DB %00001100
 .DB %10011110
 .DB %01111110
 .DB %00111100
;fonc
 .DB %00001000
 .DB %00001100
 .DB %11101010
 .DB %11011010
 .DB %10111010
 .DB %10011100
 .DB %11011100
 .DB %01111010
 .DB %00011111
 .DB %11101101
 .DB %01010011
 .DB %11101011
 .DB %00011101
 .DB %11100110
 .DB %00001110
 .DB %11110110
 .DB %00001100
 .DB %10011110
 .DB %01111110
 .DB %00111100

 .DB $FF
.end